'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * This file is `noParse` due to dynamic requires.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * Allow plugins access to the webpack-configurator config object so they can
                                                                                                                                                                                                                                                                   * add loaders, etc.
                                                                                                                                                                                                                                                                   */


exports.default = enablePlugins;

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _path = require('path');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('graphql-directory-api:enable-plugins');
function enablePlugins() {
  var plugins = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var opts = arguments[1];
  var config = arguments[2];

  plugins.forEach(function (plugin) {
    debug('enabling plugin', plugin, 'with config', opts[plugin]);
    /**
     * allow each plugin to add itself to the webpack config
     * with it's respective config, which may or may not exist
     *
     * plugins are expected to have an `index.js` which
     */
    var addPluginConfig = void 0;
    try {
      addPluginConfig = require(plugin);
    } catch (e) {
      try {
        addPluginConfig = require((0, _path.resolve)(process.cwd(), plugin));
      } catch (e) {
        throw new Error('Can not resolve plugin ' + plugin);
      }
    }
    if (typeof addPluginConfig === 'function') {
      addPluginConfig(config, _extends({}, opts[plugin] || {}, {
        leo: {
          pipeline: 'data'
        }
      }));
    } else {
      debug('plugin ' + plugin + ' does not have an index.js');
    }
  });
  return config;
}