'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref, _ref2) {
  var filepaths = _ref.filepaths,
      plugins = _ref.plugins;
  var outputPath = _ref2.outputPath;

  // merge some initial config in
  var config = {
    target: 'node',
    entry: 'database-loader?' + JSON.stringify({ files: filepaths }) + '!',
    output: {
      path: outputPath,
      filename: 'database-bundle.js',
      library: 'LEODatabase',
      libraryTarget: 'commonjs2'
    },

    resolve: {
      extensions: ['.js', '.json']
    },
    resolveLoader: {
      modules: ['node_modules',
      /**
       * Allow custom loaders to be accessed without specifying the full
       * path. ie: database-loader vs './node_modules/database-loader/...'
       * To allow this to work in dev and after build, loaders folder
       * should be at ./loaders from the artifact
       */
      (0, _path.resolve)(__dirname, './loaders')]
    },
    module: {
      noParse: [/get-plugin-schemas/, /enable-plugins/],
      rules: [{
        test: /\.jsx?$/,
        exclude: /node_modules/,
        use: [{
          loader: 'babel-loader',
          options: {
            presets: ['es2015', 'stage-0']
          }
        }]
      }]
    }
  };

  // Allow plugins to add loaders
  return config;
};