'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var _ref$plugins = _ref.plugins,
      plugins = _ref$plugins === undefined ? [] : _ref$plugins,
      _ref$data = _ref.data,
      data = _ref$data === undefined ? [] : _ref$data;

  debug('reducing plugin schema');
  return plugins.reduce(function (acc, pluginString) {
    var pluginSchemaPath = pluginString + '/schema';
    var pluginPath = void 0;
    try {
      pluginPath = require.resolve(pluginSchemaPath);
      debug('pluginSchemaPath', pluginSchemaPath);
    } catch (e) {
      try {
        pluginPath = require.resolve((0, _path.resolve)(process.cwd(), pluginSchemaPath));
      } catch (e) {
        debug('No schema for plugin', pluginString);
        return acc;
      }
    }
    var mkPluginSchema = require(pluginPath);
    /**
     * If plugin/schema is not a function, maybe we should allow it to not be
     * in the future?
     */
    if (typeof mkPluginSchema !== 'function') {
      throw new Error('plugin ' + pluginString + '/schema must export a function');
    }
    var deepClonedData = JSON.parse(JSON.stringify(data));
    // TODO: how do we handle conflicting keys? maybe just throw for now?
    return Object.assign({}, acc, mkPluginSchema(deepClonedData));
  }, {});
};

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('graphql-directory-api:get-plugin-schemas');