'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NoFieldsError = undefined;
exports.default = genSchema;

var _type = require('graphql/type');

var _type2 = _interopRequireDefault(_type);

var _getPluginSchemas = require('./get-plugin-schemas');

var _getPluginSchemas2 = _interopRequireDefault(_getPluginSchemas);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _es6Error = require('es6-error');

var _es6Error2 = _interopRequireDefault(_es6Error);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var debug = (0, _debug2.default)('graphql-directory-api:gen-schema');

var NoFieldsError = exports.NoFieldsError = function (_ExtendableError) {
  _inherits(NoFieldsError, _ExtendableError);

  function NoFieldsError() {
    _classCallCheck(this, NoFieldsError);

    return _possibleConstructorReturn(this, (NoFieldsError.__proto__ || Object.getPrototypeOf(NoFieldsError)).apply(this, arguments));
  }

  return NoFieldsError;
}(_es6Error2.default);

/**
 * Merge all plugin schemas into a single Query object
 */
function genSchema(_ref) {
  var _ref$data = _ref.data,
      data = _ref$data === undefined ? [] : _ref$data,
      _ref$plugins = _ref.plugins,
      plugins = _ref$plugins === undefined ? [] : _ref$plugins;

  /**
   * This is the root query type. We use a self-reference trick to
   * enable List responses, solving issue 112 temporarily.
   * https://github.com/facebook/relay/issues/112
   */
  var queryFields = (0, _getPluginSchemas2.default)({ plugins: plugins, data: data });

  if (Object.keys(queryFields).length === 0) {
    throw new NoFieldsError('no fields in Query schema');
  } else {
    return new _type.GraphQLSchema({
      query: new _type.GraphQLObjectType({
        name: 'Root',
        fields: function fields() {
          return {
            root: {
              type: new _type.GraphQLNonNull(new _type.GraphQLObjectType({
                name: 'Query',
                fields: function fields() {
                  return queryFields;
                }
              })),
              resolve: function resolve() {
                return {};
              }
            }
          };
        }
      })
    });
  }
}