'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NoFieldsError = exports.genSchema = exports.genDatabase = undefined;

var _genDatabase = require('./gen-database');

Object.defineProperty(exports, 'genDatabase', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_genDatabase).default;
  }
});

var _genSchema = require('./gen-schema');

Object.defineProperty(exports, 'genSchema', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_genSchema).default;
  }
});
Object.defineProperty(exports, 'NoFieldsError', {
  enumerable: true,
  get: function get() {
    return _genSchema.NoFieldsError;
  }
});
exports.default = generate;

var _genDatabase2 = _interopRequireDefault(_genDatabase);

var _genSchema2 = _interopRequireDefault(_genSchema);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function generate() {
  var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    files: [],
    plugins: [],
    pluginOpts: {},
    output: {
      dir: './dist'
    }
  };
  var cb = arguments[1];

  (0, _genDatabase2.default)(opts, function (err, data) {
    if (err) {
      return cb(err);
    }
    cb(null, {
      data: data,
      schema: (0, _genSchema2.default)({
        data: data,
        plugins: opts.plugins
      })
    });
  });
}